VTK: vtkDepthPeelingPass Class Reference

| VTK 9.0.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkDepthPeelingPass Class Reference

Implement Depth Peeling for use within a framebuffer pass. More...

`#include <vtkDepthPeelingPass.h>`

Inheritance diagram for vtkDepthPeelingPass:
[legend]
Collaboration diagram for vtkDepthPeelingPass:
[legend]

## Public Types
typedef vtkOpenGLRenderPass | Superclass
Public Types inherited from vtkOpenGLRenderPass
typedef vtkRenderPass | Superclass
Public Types inherited from vtkRenderPass
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkDepthPeelingPass * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | Render (const vtkRenderState *s) override
| Perform rendering according to a render state `s`. More...
void | ReleaseGraphicsResources (vtkWindow *w) override
| Release graphics resources and ask components to release their own resources. More...
virtual vtkRenderPass * | GetTranslucentPass ()
| Delegate for rendering the translucent polygonal geometry. More...
virtual void | SetTranslucentPass (vtkRenderPass *translucentPass)
virtual void | SetOcclusionRatio (double)
| In case of use of depth peeling technique for rendering translucent material, define the threshold under which the algorithm stops to iterate over peel layers. More...
virtual double | GetOcclusionRatio ()
virtual void | SetMaximumNumberOfPeels (int)
| In case of depth peeling, define the maximum number of peeling layers. More...
virtual int | GetMaximumNumberOfPeels ()
bool | PostReplaceShaderValues (std::string &vertexShader, std::string &geometryShader, std::string &fragmentShader, vtkAbstractMapper *mapper, vtkProp *prop) override
| Use vtkShaderProgram::Substitute to replace //VTK::XXX:YYY declarations in the shader sources. More...
bool | SetShaderParameters (vtkShaderProgram *program, vtkAbstractMapper *mapper, vtkProp *prop, vtkOpenGLVertexArrayObject *VAO=nullptr) override
| Update the uniforms of the shader program. More...
void | SetOpaqueZTexture (vtkTextureObject *)
void | SetOpaqueRGBATexture (vtkTextureObject *)
virtual void | SetDepthFormat (int)
| Set the format to use for the depth texture e.g. More...
Public Member Functions inherited from vtkOpenGLRenderPass
vtkOpenGLRenderPass * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | PreReplaceShaderValues (std::string &vertexShader, std::string &geometryShader, std::string &fragmentShader, vtkAbstractMapper *mapper, vtkProp *prop)
| Use vtkShaderProgram::Substitute to replace //VTK::XXX:YYY declarations in the shader sources. More...
virtual vtkMTimeType | GetShaderStageMTime ()
| For multi-stage render passes that need to change shader code during a single pass, use this method to notify a mapper that the shader needs to be rebuilt (rather than reuse the last cached shader. More...
virtual void | SetActiveDrawBuffers (unsigned int)
| Number of active draw buffers. More...
virtual unsigned int | GetActiveDrawBuffers ()
Public Member Functions inherited from vtkRenderPass
vtkRenderPass * | NewInstance () const
virtual int | GetNumberOfRenderedProps ()
| Number of props rendered at the last Render call. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
vtkCommand * | GetCommand (unsigned long tag)
void | RemoveObserver (vtkCommand *)
void | RemoveObservers (unsigned long event, vtkCommand *)
void | RemoveObservers (const char *event, vtkCommand *)
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
int | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
int | InvokeEvent (const char *event, void *callData)
int | InvokeEvent (unsigned long event)
int | InvokeEvent (const char *event)
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
void | PrintRevisions (ostream &)
| Legacy. More...

## Static Public Member Functions
static vtkDepthPeelingPass * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkDepthPeelingPass * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkOpenGLRenderPass
static vtkTypeBool | IsTypeOf (const char *type)
static vtkOpenGLRenderPass * | SafeDownCast (vtkObjectBase *o)
static vtkInformationObjectBaseVectorKey * | RenderPasses ()
| Key containing information about the current pass. More...
Static Public Member Functions inherited from vtkRenderPass
static vtkTypeBool | IsTypeOf (const char *type)
static vtkRenderPass * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (int val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
static void | GlobalWarningDisplayOff ()
static int | GetGlobalWarningDisplay ()
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkDepthPeelingPass ()
| Default constructor. More...
| ~vtkDepthPeelingPass () override
| Destructor. More...
void | BlendIntermediatePeels (vtkOpenGLRenderWindow *renWin, bool)
void | BlendFinalPeel (vtkOpenGLRenderWindow *renWin)
Protected Member Functions inherited from vtkOpenGLRenderPass
| vtkOpenGLRenderPass ()
| ~vtkOpenGLRenderPass () override
void | PreRender (const vtkRenderState *s)
| Call before rendering to update the actors' information keys. More...
void | PostRender (const vtkRenderState *s)
| Call after rendering to clean up the actors' information keys. More...
Protected Member Functions inherited from vtkRenderPass
| vtkRenderPass ()
| Default constructor. More...
| ~vtkRenderPass () override
| Destructor. More...
void | UpdateCamera (vtkRenderer *renderer)
| Call UpdateCamera() on Renderer. More...
void | ClearLights (vtkRenderer *renderer)
| Call ClearLights() on Renderer. More...
void | UpdateLightGeometry (vtkRenderer *renderer)
| Call UpdateLightGeometry() on Renderer. More...
void | UpdateLights (vtkRenderer *renderer)
| Call UpdateLights() on Renderer. More...
void | UpdateGeometry (vtkRenderer *renderer, vtkFrameBufferObjectBase *fbo=nullptr)
| Call UpdateGeometry() on Renderer. More...
void | SetLastRenderingUsedDepthPeeling (vtkRenderer *renderer, bool value)
| Modify protected member LastRenderingUsedDepthPeeling on Renderer. More...
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | CollectRevisions (ostream &)
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkRenderPass * | TranslucentPass
vtkTimeStamp | CheckTime
int | ViewportX
| Cache viewport values for depth peeling. More...
int | ViewportY
int | ViewportWidth
int | ViewportHeight
double | OcclusionRatio
| In case of use of depth peeling technique for rendering translucent material, define the threshold under which the algorithm stops to iterate over peel layers. More...
int | MaximumNumberOfPeels
| In case of depth peeling, define the maximum number of peeling layers. More...
vtkOpenGLFramebufferObject * | Framebuffer
vtkOpenGLQuadHelper * | FinalBlend
vtkOpenGLQuadHelper * | IntermediateBlend
vtkTextureObject * | OpaqueZTexture
vtkTextureObject * | OpaqueRGBATexture
bool | OwnOpaqueZTexture
bool | OwnOpaqueRGBATexture
vtkTextureObject * | TranslucentRGBATexture [3]
int | ColorDrawCount
int | PeelCount
vtkTextureObject * | TranslucentZTexture [2]
int | DepthFormat
vtkOpenGLState * | State
Protected Attributes inherited from vtkOpenGLRenderPass
unsigned int | ActiveDrawBuffers = 0
Protected Attributes inherited from vtkRenderPass
int | NumberOfRenderedProps
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

Implement Depth Peeling for use within a framebuffer pass.

Note that this implementation is used as a fallback for drivers that don't support floating point textures. Most renderings will use the subclass vtkDualDepthPeelingPass instead.

Render the translucent polygonal geometry of a scene without sorting polygons in the view direction.

This pass expects an initialized depth buffer and color buffer. Initialized buffers means they have been cleared with farest z-value and background color/gradient/transparent color. An opaque pass may have been performed right after the initialization.

The depth peeling algorithm works by rendering the translucent polygonal geometry multiple times (once for each peel). The actually rendering of the translucent polygonal geometry is performed by its delegate TranslucentPass. This delegate is therefore used multiple times.

Its delegate is usually set to a vtkTranslucentPass.

This implementation makes use of textures and is suitable for ES3 For ES3 it must be embedded within a pass that makes use of framebuffers so that the required OpaqueZTexture and OpaqueRGBATexture can be passed from the outer framebuffer pass. For OpenGL ES3 be aware the occlusion ratio test is not supported. The maximum number of peels is used instead so set it to a reasonable value. For many scenes a value of 4 or 5 will work well.

See also
  vtkRenderPass, vtkTranslucentPass, vtkFramebufferPass

Definition at line 63 of file vtkDepthPeelingPass.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkOpenGLRenderPass vtkDepthPeelingPass::Superclass

Definition at line 67 of file vtkDepthPeelingPass.h.

## Constructor & Destructor Documentation

## ◆ vtkDepthPeelingPass()

vtkDepthPeelingPass::vtkDepthPeelingPass | ( |  | ) |
| protected

Default constructor.

TranslucentPass is set to NULL.

## ◆ ~vtkDepthPeelingPass()

vtkDepthPeelingPass::~vtkDepthPeelingPass | ( |  | ) |
| overrideprotected

Destructor.

## Member Function Documentation

## ◆ New()

static vtkDepthPeelingPass* vtkDepthPeelingPass::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkDepthPeelingPass::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkDepthPeelingPass::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkOpenGLRenderPass.

Reimplemented in vtkDualDepthPeelingPass.

## ◆ SafeDownCast()

static vtkDepthPeelingPass* vtkDepthPeelingPass::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkDepthPeelingPass::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkOpenGLRenderPass.

Reimplemented in vtkDualDepthPeelingPass.

## ◆ NewInstance()

vtkDepthPeelingPass* vtkDepthPeelingPass::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkDepthPeelingPass::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkRenderPass.

Reimplemented in vtkDualDepthPeelingPass.

## ◆ Render()

void vtkDepthPeelingPass::Render | ( | const vtkRenderState * | s | ) |
| overridevirtual

Perform rendering according to a render state `s`.

Precondition
  s_exists: s!=0

Implements vtkRenderPass.

Reimplemented in vtkDualDepthPeelingPass.

## ◆ ReleaseGraphicsResources()

void vtkDepthPeelingPass::ReleaseGraphicsResources | ( | vtkWindow * | w | ) |
| overridevirtual

Release graphics resources and ask components to release their own resources.

Precondition
  w_exists: w!=0

Reimplemented from vtkRenderPass.

Reimplemented in vtkDualDepthPeelingPass.

## ◆ GetTranslucentPass()

virtual vtkRenderPass* vtkDepthPeelingPass::GetTranslucentPass | ( |  | ) |
| virtual

Delegate for rendering the translucent polygonal geometry.

If it is NULL, nothing will be rendered and a warning will be emitted. It is usually set to a vtkTranslucentPass. Initial value is a NULL pointer.

## ◆ SetTranslucentPass()

virtual void vtkDepthPeelingPass::SetTranslucentPass | ( | vtkRenderPass * | translucentPass | ) |
| virtual

## ◆ SetOcclusionRatio()

virtual void vtkDepthPeelingPass::SetOcclusionRatio | ( | double |  | ) |
| virtual

In case of use of depth peeling technique for rendering translucent material, define the threshold under which the algorithm stops to iterate over peel layers.

This is the ratio of the number of pixels that have been touched by the last layer over the total number of pixels of the viewport area. Initial value is 0.0, meaning rendering have to be exact. Greater values may speed-up the rendering with small impact on the quality.

## ◆ GetOcclusionRatio()

virtual double vtkDepthPeelingPass::GetOcclusionRatio | ( |  | ) |
| virtual

## ◆ SetMaximumNumberOfPeels()

virtual void vtkDepthPeelingPass::SetMaximumNumberOfPeels | ( | int |  | ) |
| virtual

In case of depth peeling, define the maximum number of peeling layers.

Initial value is 4. A special value of 0 means no maximum limit. It has to be a positive value.

## ◆ GetMaximumNumberOfPeels()

virtual int vtkDepthPeelingPass::GetMaximumNumberOfPeels | ( |  | ) |
| virtual

## ◆ PostReplaceShaderValues()

bool vtkDepthPeelingPass::PostReplaceShaderValues | ( | std::string & | vertexShader,
|  | std::string & | geometryShader,
|  | std::string & | fragmentShader,
|  | vtkAbstractMapper * | mapper,
|  | vtkProp * | prop
| ) |  |
| overridevirtual

Use vtkShaderProgram::Substitute to replace //VTK::XXX:YYY declarations in the shader sources.

Gets called after other mapper shader replacements. Return false on error.

Reimplemented from vtkOpenGLRenderPass.

Reimplemented in vtkDualDepthPeelingPass.

## ◆ SetShaderParameters()

bool vtkDepthPeelingPass::SetShaderParameters | ( | vtkShaderProgram * | program,
|  | vtkAbstractMapper * | mapper,
|  | vtkProp * | prop,
|  | vtkOpenGLVertexArrayObject * | VAO = `nullptr`
| ) |  |
| overridevirtual

Update the uniforms of the shader program.

Return false on error.

Reimplemented from vtkOpenGLRenderPass.

Reimplemented in vtkDualDepthPeelingPass.

## ◆ SetOpaqueZTexture()

void vtkDepthPeelingPass::SetOpaqueZTexture | ( | vtkTextureObject * |  | ) |

## ◆ SetOpaqueRGBATexture()

void vtkDepthPeelingPass::SetOpaqueRGBATexture | ( | vtkTextureObject * |  | ) |

## ◆ SetDepthFormat()

virtual void vtkDepthPeelingPass::SetDepthFormat | ( | int |  | ) |
| virtual

Set the format to use for the depth texture e.g.

vtkTextureObject::Float32

## ◆ BlendIntermediatePeels()

void vtkDepthPeelingPass::BlendIntermediatePeels | ( | vtkOpenGLRenderWindow * | renWin,
|  | bool |
| ) |  |
| protected

## ◆ BlendFinalPeel()

void vtkDepthPeelingPass::BlendFinalPeel | ( | vtkOpenGLRenderWindow * | renWin | ) |
| protected

## Member Data Documentation

## ◆ TranslucentPass

vtkRenderPass* vtkDepthPeelingPass::TranslucentPass
| protected

Definition at line 147 of file vtkDepthPeelingPass.h.

## ◆ CheckTime

vtkTimeStamp vtkDepthPeelingPass::CheckTime
| protected

Definition at line 148 of file vtkDepthPeelingPass.h.

## ◆ ViewportX

int vtkDepthPeelingPass::ViewportX
| protected

Cache viewport values for depth peeling.

Definition at line 154 of file vtkDepthPeelingPass.h.

## ◆ ViewportY

int vtkDepthPeelingPass::ViewportY
| protected

Definition at line 155 of file vtkDepthPeelingPass.h.

## ◆ ViewportWidth

int vtkDepthPeelingPass::ViewportWidth
| protected

Definition at line 156 of file vtkDepthPeelingPass.h.

## ◆ ViewportHeight

int vtkDepthPeelingPass::ViewportHeight
| protected

Definition at line 157 of file vtkDepthPeelingPass.h.

## ◆ OcclusionRatio

double vtkDepthPeelingPass::OcclusionRatio
| protected

In case of use of depth peeling technique for rendering translucent material, define the threshold under which the algorithm stops to iterate over peel layers.

This is the ratio of the number of pixels that have been touched by the last layer over the total number of pixels of the viewport area. Initial value is 0.0, meaning rendering have to be exact. Greater values may speed-up the rendering with small impact on the quality.

Definition at line 169 of file vtkDepthPeelingPass.h.

## ◆ MaximumNumberOfPeels

int vtkDepthPeelingPass::MaximumNumberOfPeels
| protected

In case of depth peeling, define the maximum number of peeling layers.

Initial value is 4. A special value of 0 means no maximum limit. It has to be a positive value.

Definition at line 176 of file vtkDepthPeelingPass.h.

## ◆ Framebuffer

vtkOpenGLFramebufferObject* vtkDepthPeelingPass::Framebuffer
| protected

Definition at line 178 of file vtkDepthPeelingPass.h.

## ◆ FinalBlend

vtkOpenGLQuadHelper* vtkDepthPeelingPass::FinalBlend
| protected

Definition at line 180 of file vtkDepthPeelingPass.h.

## ◆ IntermediateBlend

vtkOpenGLQuadHelper* vtkDepthPeelingPass::IntermediateBlend
| protected

Definition at line 181 of file vtkDepthPeelingPass.h.

## ◆ OpaqueZTexture

vtkTextureObject* vtkDepthPeelingPass::OpaqueZTexture
| protected

Definition at line 184 of file vtkDepthPeelingPass.h.

## ◆ OpaqueRGBATexture

vtkTextureObject* vtkDepthPeelingPass::OpaqueRGBATexture
| protected

Definition at line 185 of file vtkDepthPeelingPass.h.

## ◆ OwnOpaqueZTexture

bool vtkDepthPeelingPass::OwnOpaqueZTexture
| protected

Definition at line 186 of file vtkDepthPeelingPass.h.

## ◆ OwnOpaqueRGBATexture

bool vtkDepthPeelingPass::OwnOpaqueRGBATexture
| protected

Definition at line 187 of file vtkDepthPeelingPass.h.

## ◆ TranslucentRGBATexture

vtkTextureObject* vtkDepthPeelingPass::TranslucentRGBATexture[3]
| protected

Definition at line 190 of file vtkDepthPeelingPass.h.

## ◆ ColorDrawCount

int vtkDepthPeelingPass::ColorDrawCount
| protected

Definition at line 191 of file vtkDepthPeelingPass.h.

## ◆ PeelCount

int vtkDepthPeelingPass::PeelCount
| protected

Definition at line 192 of file vtkDepthPeelingPass.h.

## ◆ TranslucentZTexture

vtkTextureObject* vtkDepthPeelingPass::TranslucentZTexture[2]
| protected

Definition at line 195 of file vtkDepthPeelingPass.h.

## ◆ DepthFormat

int vtkDepthPeelingPass::DepthFormat
| protected

Definition at line 196 of file vtkDepthPeelingPass.h.

## ◆ State

vtkOpenGLState* vtkDepthPeelingPass::State
| protected

Definition at line 202 of file vtkDepthPeelingPass.h.

The documentation for this class was generated from the following file:

- Rendering/OpenGL2/vtkDepthPeelingPass.h